/*Codigo 10.2*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <netdb.h>

extern int h_errno;

int main(int argc, char **argv)
{
  
	struct hostent *Host;
	int i;

	if(argc < 1)
	{
		printf("Erro! Uso: ./resolve nome_do_host\n");
		exit(1);
	}

	Host = gethostbyname(argv[1]);
	if(Host == NULL)
	{
		fprintf(stderr,"Erro ao resolver %s: %s\n",                                                                                                           
                         argv[1],
                         hstrerror(h_errno));
		exit(2);
	}
	printf("Informacoes do host -> %s\n",argv[1]);
	
	printf("Nome oficial: %s\n\n",Host->h_name);
	
	printf("Apelidos (alias):\n\n");
	for(i=0;Host->h_aliases[i]!=NULL;i++)
		printf("Alias %d: %s\n",i+1,Host->h_aliases[i]); 

	printf("\nEndereco IP: %s\n",
	       inet_ntoa(*(struct in_addr *)Host->h_addr_list[0]));
			
}
