/*Codigo 13.1*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>

int main()
{
	struct sockaddr_in EndBcast, EndLocal;
	int sockfd, lenBcast, lenLocal, retorno, lenBuffer;
	int broadcast = 1;
	char buffer[1000];

	sockfd = socket(PF_INET, SOCK_DGRAM,0);
	retorno = setsockopt(sockfd,
					  SOL_SOCKET,
					  SO_BROADCAST,
					  &broadcast,
					  sizeof broadcast);
	if(retorno==-1)
	{
		perror("Erro em setsockopt: ");
		exit(1);
	} 
	lenBcast = sizeof(EndBcast);
	memset((struct sockaddr_in *)&(EndBcast),0,lenBcast);
	EndBcast.sin_family = PF_INET;
	EndBcast.sin_port = htons(8000);
	EndBcast.sin_addr.s_addr = inet_addr("10.163.47.255");

	lenLocal = sizeof(EndLocal);
	memset((struct sockaddr_in *)&(EndLocal),0,lenLocal);
	EndLocal.sin_family = PF_INET;
	EndLocal.sin_port = htons(8000);
	EndLocal.sin_addr.s_addr = inet_addr("10.163.45.169");
	retorno = bind(sockfd, 
				(struct sockaddr*)&EndLocal,
				lenLocal);

	strcpy(buffer,"Oi");
	lenBuffer = sizeof(buffer);
	retorno = sendto(sockfd,buffer,lenBuffer,0,
				  (struct sockaddr*)&EndBcast,
				  lenBcast);
	if(retorno == -1)
	{
		perror("Nao foi possivel enviar broadcast: ");
		exit(1);
	}
	printf("Broadcast enviado com sucesso!\n");
	close(sockfd);
	exit(0);
}
