/*Codigo 7.3*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>

struct Amst
{
	int cpu;
	int memoria;
};




/*Funcao do Codigo 7.4b*/
int SocketUDP()
{
	struct sockaddr_in EndLocal;
	int sockfd, lenLocal, retorno;

	sockfd = socket(PF_INET, SOCK_DGRAM,0);

	lenLocal = sizeof(EndLocal);
	memset((struct sockaddr_in *)&(EndLocal),0,lenLocal);
	EndLocal.sin_family = PF_INET;
	EndLocal.sin_port = htons(9000);
	EndLocal.sin_addr.s_addr = inet_addr("127.0.0.1");
	retorno = bind(sockfd, 
				(struct sockaddr*)&EndLocal,
				lenLocal);
	return sockfd;
}

/*Funcao do Codigo 7.4b*/
struct Amst ReceberAmostra(int sockfd, char *Alvo)
{
	struct Amst Amostra;
	struct sockaddr_in EndAlvo;
	int lenAmostra, lenAlvo;
	int retorno;

	lenAmostra = sizeof(Amostra);
	retorno = recvfrom(sockfd,&Amostra,lenAmostra,0,
				     (struct sockaddr*)&EndAlvo,
				     &lenAlvo);

	strcpy(Alvo,(char*)inet_ntoa(EndAlvo.sin_addr));
	printf("%s\n",inet_ntoa(EndAlvo.sin_addr));

	return Amostra;
}

/*Funcao do Codigo 7.4b*/
int GravarAmostra(struct Amst Amostra, char *Alvo)
{
	FILE *fAmostra;
	char *NmArquivo;
	struct tm *ptr;
	time_t lt;

	NmArquivo = malloc(sizeof(char)*100);
	sprintf(NmArquivo,"%s.amst",Alvo);
	fAmostra = fopen(NmArquivo,"a+");

	lt = time(NULL);
	ptr = localtime(&lt);


	fprintf(fAmostra,"%d:%d:%d %d %d\n",
			ptr->tm_hour,
			ptr->tm_min,
			ptr->tm_sec,
			Amostra.cpu,
			Amostra.memoria);

	fclose(fAmostra);
}

int main()
{
	struct Amst Amostra;
	int sockfd;
	char *Alvo;
	
	Alvo = malloc(sizeof(char)*100);

	sockfd = SocketUDP();
	while(1)
	{
		Amostra = ReceberAmostra(sockfd,Alvo);
		GravarAmostra(Amostra,Alvo);
	}
}
