/*Codigo 8.1*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip_icmp.h>



struct myicmp 
{
 	unsigned char type;
 	unsigned char code;
 	unsigned short int cksum;
 	unsigned short int seq;
 	unsigned short int id;
 	char data[10];
};


/*Funcao do Codigo 8.4a*/
void Aguardar()
{
	int i;
	for(i=0;i<=999999;i++);
}


/*Funcao do Codigo 8.4a*/
#define TAM_PACOTE 38 //Devem ser colocadas no in�cio do arquivo fonte
#define TAM_CABECALHO_IP 20 //�dem

int ReceberEco(int sockfd, struct sockaddr_in EndDestino, int idPkt)
{
    	struct ip *IP;
    	struct myicmp *ICMP;

	int len;
    	int bytesRecebidos;
    	int i;

    	char Pacote[TAM_PACOTE];

    	len = sizeof(struct sockaddr_in);

    	Aguardar();
	bytesRecebidos = recvfrom(	sockfd,
					     	Pacote,
                                	TAM_PACOTE,
                                	MSG_DONTWAIT,
                               	(struct sockaddr*)&EndDestino,
 						&len);
    	if(bytesRecebidos == -1)
    	{
      	printf("IP %s nao respondeu!\n",inet_ntoa(EndDestino.sin_addr));
        	exit(1);
    	}

    	IP = ( struct ip* )Pacote;
    	ICMP = (struct myicmp*) (Pacote + TAM_CABECALHO_IP);

    	printf("Resposta de Eco: %s\n",inet_ntoa(EndDestino.sin_addr));
    	printf("Tipo: %d\n",ICMP->type);
    	printf("Codigo: %d\n",ICMP->code);
    	printf("ID Enviado: %d\n",idPkt);
	printf("ID Recebido: %d\n",ICMP->id);
    	printf("Seq: %d\n",ICMP->seq);
    	printf("Dados: %s\n",ICMP->data);
}

/*Funcao do Codigo 8.4a*/
int in_cksum( u_short *p, int n )
{
 	register u_short answer;
      register long sum = 0;
      u_short odd_byte = 0;

      while( n > 1 )
      {
      	sum += *p++;
         	n -= 2;

      }

      if( n == 1 )
      {
      	*( u_char* )( &odd_byte ) = *( u_char* )p;
         	sum += odd_byte;

      }
      sum = ( sum >> 16 ) + ( sum & 0xffff );        
      sum += ( sum >> 16 );                                                                                                                  
      answer = ~sum;                                                  

      return ((int) answer );
} 


/*Funcao do Codigo 8.4a*/
int EnviarEco(int sockfd, struct sockaddr_in EndDestino)
{

    	struct myicmp ICMP;
    	int bytesEnviados;
	int len;

    	ICMP.type = ICMP_ECHO;
    	ICMP.code = 0;
    	ICMP.seq = 0;
    	ICMP.id = getpid();
    	ICMP.cksum = 0;
    	strcpy(ICMP.data,"cristiane");

    	ICMP.cksum = in_cksum((u_short*)&ICMP,sizeof(ICMP));
	
	len = sizeof(EndDestino);
    	bytesEnviados = sendto(sockfd, 
					   &ICMP,
					   sizeof(ICMP),
					   0,
				   	   (struct sockaddr*)&EndDestino, 
					   len);
    	if(bytesEnviados == -1)
		exit(1);
	return ICMP.id;
}



int main(int argc, char* argv[])
{
   	int sockfd;
   	int idPkt;
    	struct sockaddr_in EndDestino;
    	int pktEnviado;
    	int pktRecebido;

	sockfd = socket(AF_INET,SOCK_RAW,1);

	EndDestino.sin_family = AF_INET;
    	EndDestino.sin_addr.s_addr = inet_addr(argv[1]);     
    
    	idPkt = EnviarEco(sockfd, EndDestino);
    	ReceberEco(sockfd, EndDestino, idPkt);
	
	close(sockfd);
}
