/*Codigo 12.3*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <wait.h>
#include <time.h>

char *HoraData()
{
        struct tm *ptr;
        time_t lt;

        lt = time(NULL);
        ptr = (struct tm *) localtime(&lt);
        return (char*)asctime(ptr);
}



static void TratarFilhos(int signo)
{
        pid_t ProcessoFilho;
        int status;

        do
        {
                ProcessoFilho = waitpid(-1,&status,WNOHANG);
        }while ( ProcessoFilho != -1 );

        signal(SIGCHLD,TratarFilhos);
}


int main()
{
	struct sockaddr_in EndLocal, EndRemoto;
	int sockfd, len, retorno, lenRemoto;
	int cliente;
	pid_t ProcessoFilho;
	char *buffer;

	buffer = malloc(sizeof(char)*100);

	signal(SIGCHLD,TratarFilhos);
	sockfd = socket(PF_INET, SOCK_STREAM,0);

   	len = sizeof(EndLocal);

   	memset((struct sockaddr_in *)&(EndLocal),0,len);
   	EndLocal.sin_family = PF_INET;
   	EndLocal.sin_port = htons(4040);
   	EndLocal.sin_addr.s_addr = inet_addr("127.0.0.1");

	retorno = bind(sockfd,(struct sockaddr*)&EndLocal,len);
	if(retorno == -1)
		exit(0);
	
	listen(sockfd,5);
	
	while(1)
	{
		cliente = accept(sockfd,
				      (struct sockaddr *)&EndRemoto,
                           &lenRemoto);

		ProcessoFilho = fork();
		if(ProcessoFilho == -1) /*Erro na execu��o de fork()*/
		{
			close(cliente);
			continue;
		}
		else if(ProcessoFilho > 0)
		{
			close(cliente);
			continue;
		}
		buffer = HoraData();
		sleep(10);
		send(cliente,buffer,strlen(buffer),0);
		close(cliente);
		exit(0);
	}
}
