	/*Codigo 13.2*/
	#include <stdio.h>
	#include <stdlib.h>
	#include <errno.h>
	#include <string.h>
	#include <sys/socket.h>
	#include <netinet/in.h>

	int main()
	{
		struct sockaddr_in EndBcast, EndRemoto;
		int sockfd, lenBcast, lenRemoto, retorno, lenBuffer;
		int reuseaddr = 1;
		char buffer[1000];

		sockfd = socket(PF_INET, SOCK_DGRAM,0);

		retorno = setsockopt(sockfd,
						  SOL_SOCKET,
						  SO_REUSEADDR,
						  &reuseaddr,
						  sizeof reuseaddr);
		if(retorno==-1)
		{
			perror("Erro em setsockopt: ");
			exit(1);
		} 

		lenBcast = sizeof(EndBcast);

		memset((struct sockaddr_in *)&(EndBcast),0,lenBcast);
		EndBcast.sin_family = PF_INET;
		EndBcast.sin_port = htons(8000);
		EndBcast.sin_addr.s_addr = inet_addr("10.163.47.255");

		retorno = bind(sockfd, 
					(struct sockaddr*)&EndBcast,
					lenBcast);

		lenBuffer = sizeof(buffer);
		retorno = recvfrom(sockfd,buffer,lenBuffer,0,
					    (struct sockaddr*)&EndRemoto,
					    &lenRemoto);
	

	printf("Broadcast recebido: %s\n",buffer);
	printf("Servidor respons�vel pelo envio: %s\n",inet_ntoa(EndRemoto.sin_addr));
	close(sockfd);
	exit(0);
}
