/*Codigo 7.2*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define INTERVALO 5

//extern FILE *stdout;

struct Amst
{
	int cpu;
	int memoria;
};




/*Funcao do Codigo 7.4a*/
struct Amst ColetarAmostra()
{
	struct Amst Amostra;
	FILE *tmp;
	char *aux;

	aux = (char*)malloc(sizeof(char)*100);	

	system("vmstat 1 2 | tail -1 | gawk -F\" \" '{ print $13 }' > /tmp/amostra");
	tmp = fopen("/tmp/amostra","r");	
	fscanf(tmp,"%s",aux);
	Amostra.cpu = atoi(aux);
	
	system("vmstat 1 2 | tail -1 | gawk -F\" \" '{ print $4 }' > /tmp/amostra");
	tmp = fopen("/tmp/amostra","r");	
	fscanf(tmp,"%s",aux);
	Amostra.memoria = atoi(aux);

	return Amostra;

}


/*Funcao do Codigo 7.4a*/
int EnviarAmostra(struct Amst Amostra)
{
	struct sockaddr_in EndConcentrador;
	int sockfd, lenConcentrador, retorno, lenAmostra;

	sockfd = socket(PF_INET, SOCK_DGRAM,0);

	lenConcentrador = sizeof(EndConcentrador);

	memset((struct sockaddr_in *)&(EndConcentrador),0,lenConcentrador);
	EndConcentrador.sin_family = PF_INET;
	EndConcentrador.sin_port = htons(9000);
	EndConcentrador.sin_addr.s_addr = inet_addr("127.0.0.1");

	lenAmostra = sizeof(Amostra);
	retorno = sendto(sockfd,&Amostra,lenAmostra,0,
				   (struct sockaddr*)&EndConcentrador,
				   lenConcentrador);
	return retorno;
}


int main()
{
	struct Amst Amostra;
	int retorno;

	while(1)
	{
		Amostra = ColetarAmostra();
		retorno = EnviarAmostra(Amostra);
		if(retorno == -1)
		{
			printf("Erro de envio de amostra!");
			exit(1);
		}
		sleep(INTERVALO);
	}
}
