#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <signal.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <netdb.h>



#define INVNT 100
#define BCAST 200
#define PRNTO 300

struct Host
{
        char *IP;
      //  int sizeHost;
};


//struct Host HostsAtivos[100];


struct InvDados
{
        char Kernel[100];
        char CPU[100];
        char MemTotal[100];
        char MemLivre[100];

        int sizeKernel;
        int sizeCPU;
        int sizeMemTotal;
        int sizeMemLivre;
};

int CriarSocketEnviarBCAST()
{
        struct sockaddr_in EndLocal;
        int sockfd, len, retorno;
        int broadcast = 1;
        retorno = sockfd = socket(PF_INET, SOCK_DGRAM,0);

	setsockopt(sockfd,SOL_SOCKET,SO_BROADCAST,&broadcast,sizeof broadcast);

        if(retorno <= 0)
                close(sockfd);
        return retorno;


}

int CriarSocketReceberPRNTO(int porta)
{
        struct sockaddr_in EndLocal;
        int sockfd, len, retorno;
        retorno = sockfd = socket(PF_INET, SOCK_DGRAM,0);

	len = sizeof(EndLocal);
	memset((struct sockaddr_in*)&(EndLocal),0,len);
        
        EndLocal.sin_family = PF_INET;
        EndLocal.sin_port = htons(porta);
        EndLocal.sin_addr.s_addr = inet_addr("127.0.0.1");
	
	if((bind(sockfd,(struct sockaddr *) &EndLocal,len)) == -1)
                retorno = -1;
        if(retorno <= 0)
                close(sockfd);
        return retorno;


}



int ConectarHost(struct Host HostAtivo)
{
	int bytes = 0, sizeADM, len, sizeComando, Comando;
	struct sockaddr_in EndLocal;
	int Sockfd, SocketClient;
	Sockfd = socket(PF_INET,SOCK_STREAM,0);

	
	len = sizeof(EndLocal);
	memset((struct sockaddr_in*)&(EndLocal),0,len);
        EndLocal.sin_family = PF_INET;
        EndLocal.sin_port = htons(3000);
        EndLocal.sin_addr.s_addr = inet_addr(HostAtivo.IP);
	
	SocketClient = connect(Sockfd,(struct sockaddr *)&EndLocal,len);
	if(SocketClient == -1)
		exit(0);
	return Sockfd;
}

int EnviarComandoInventario(int SocketDados)
{
	int Msg,Len,Bytes;
	Msg = INVNT;
	Len = sizeof(Msg);
	Bytes = send(SocketDados,&Msg,Len,0);
}

struct InvDados ReceberDadosInventario(int SocketDados)
{
	struct InvDados Dados;
	int Len,Bytes;
	Len = sizeof(Dados);
	Bytes = recv(SocketDados,&Dados,Len,0);
	//Dados.CPU[Dados.sizeCPU] = '\0';
	return Dados;
}

int GravarDadosSocketLocal(struct InvDados DadosInventario)
{
}


char *ResolverNome(char *IP)
{
	char *Nome;
	struct in_addr end;
	struct hostent *ResNome;
	
	Nome = malloc(sizeof(char)*300);

	end.s_addr = inet_addr(IP);
	ResNome = gethostbyaddr(&end,sizeof(end),AF_INET);
	
	strcpy(Nome,ResNome->h_name);
	return Nome;
}

int GravarLog(struct InvDados DadosInventario, struct Host HostAtivo)
{
	char *NomeHost;
	FILE *log;
	
	log = fopen("/tmp/inventario.log","a+");

	NomeHost = ResolverNome(HostAtivo.IP);

	fprintf(log,"Host: %s\n",NomeHost);
        fprintf(log,"CPU: %s\n",DadosInventario.CPU);
        fprintf(log,"Kernel: %s\n",DadosInventario.Kernel);
        fprintf(log,"Memória Total: %s\n",DadosInventario.MemTotal);
        fprintf(log,"Memória Livre: %s\n",DadosInventario.MemLivre);
	fprintf(log,"\n************************************************************");
	
	/*printf("Host: %s\n",NomeHost);
	printf("CPU: %s\n",DadosInventario.CPU);
	printf("Kernel: %s\n",DadosInventario.Kernel);
	printf("Memória Total: %s\n",DadosInventario.MemTotal);
	printf("Memória Livre: %s\n",DadosInventario.MemLivre);*/
	
}

int EnviarRequisicaoBroadcast(int SocketBcast, int porta)
{
	struct sockaddr_in EndBcast;
	int msg = BCAST;
	int len;
	len = sizeof(EndBcast);
	int retorno;

	memset((struct sockaddr_in*)&(EndBcast),0,len);
        EndBcast.sin_family = PF_INET;
        EndBcast.sin_port = htons(porta);
//        EndBcast.sin_addr.s_addr = inet_addr("10.163.47.255");
	EndBcast.sin_addr.s_addr = inet_addr("127.255.255.255");
	
	retorno = sendto(SocketBcast,&msg,sizeof(msg),0,(struct sockaddr*)&EndBcast,len);
	printf("Retorno de sendto: %d",retorno);
}

int IdentificarHostsAtivos( struct Host *HostsAtivos)
{
	int SocketBCAST,SocketPRNTO,i;
	int Msg,Len,LenClient,Bytes;
	struct sockaddr_in EndClient;
	struct Host Aux;
	int Indice = 0;
	
	Bytes = 0;
	Len = sizeof(Msg);
	LenClient = sizeof(EndClient);

	SocketBCAST = CriarSocketEnviarBCAST();
	EnviarRequisicaoBroadcast(SocketBCAST,9090);
	SocketPRNTO = CriarSocketReceberPRNTO(9090);
	sleep(10);
	
	for(i=0;i<=100;i++)
	{
		Bytes = recvfrom(SocketPRNTO,&Msg,Len,MSG_DONTWAIT,(struct sockaddr *)&EndClient,&LenClient);
	
		if(Bytes > 0)
		{
			HostsAtivos[Indice].IP = malloc(sizeof(char)*300);
			sprintf(HostsAtivos[Indice].IP,"%s",inet_ntoa(EndClient.sin_addr));
			Indice++;
			printf("Respondeu!\n");
			
			
		}
	}
	return Indice;
}

int ObterDadosInventario(int QtdeHosts, struct Host *HostsAtivos)
{
	int i;
	int SocketDados;
	struct InvDados DadosInventario;
	for(i=0;i<=QtdeHosts-1;i++)
	{
		SocketDados = ConectarHost(HostsAtivos[i]);
		EnviarComandoInventario(SocketDados);
		DadosInventario = ReceberDadosInventario(SocketDados);
		GravarLog(DadosInventario,HostsAtivos[i]);
		
	}
}

int main(int argc, char *argv[])
{
	int QtdeHosts;
	struct Host HostsAtivos[100];

	QtdeHosts = IdentificarHostsAtivos(HostsAtivos);
	ObterDadosInventario(QtdeHosts, HostsAtivos);
		

}
